"use strict";

var _Object$assign = require("babel-runtime/core-js/object/assign")["default"];

var _interopRequireWildcard = require("babel-runtime/helpers/interop-require-wildcard")["default"];

exports.__esModule = true;

var _generatorsBase = require("./generators/base");

var _base = _interopRequireWildcard(_generatorsBase);

// import * as _jsx from "./generators/jsx";
// import * as _flow from "./generators/flow";
// import * as _modules from "./generators/modules";
// import * as _templateLiterals from "./generators/templateLiterals";
// NOTE: these are only the types with shared syntax. Arrays literals, object
// literals, and possibly regex types will have minor differences
// import * as _types from "./generators/simpleTypes";

var commonPrinterMethods = {
  generate: function generate() {
    this.tokenize();
    var code = this.stringify();

    return {
      code: code,
      tokens: this.tokens,
      map: this.getMap()
    };
  },

  getMap: function getMap() {
    var map = this.map;
    return map ? map.toJSON() : map;
  },

  // Comments printing methods. "borrowed" from babel-generator

  getComments: function getComments(key, node) {
    return node && node[key] || [];
  },

  printComments: function printComments(comments, attachedNode) {
    if (!comments || !comments.length) return;

    var _arr = comments;
    for (var _i = 0; _i < _arr.length; _i++) {
      var comment = _arr[_i];
      // language-specific printers should implement printComment
      this.printComment(comment);
    }
  },

  printInnerComments: function printInnerComments(node) {
    var indent = arguments.length <= 1 || arguments[1] === undefined ? true : arguments[1];

    if (!node.innerComments) return;
    if (indent) this.indent();
    this.printComments(node.innerComments);
    if (indent) this.dedent();
  },

  shouldPrintComment: function shouldPrintComment(comment) {
    return true;
    // if (this.format.shouldPrintComment) {
    //   return this.format.shouldPrintComment(comment.value);
    // } else {
    //   if (comment.value.indexOf("@license") >= 0 || comment.value.indexOf("@preserve") >= 0) {
    //     return true;
    //   } else {
    //     return this.format.comments;
    //   }
    // }
  }

};
exports["default"] = commonPrinterMethods;

// TODO: submit babel bug?
commonPrinterMethods["default"] = commonPrinterMethods;

var _arr2 = [_base /*, _types*/];
for (var _i2 = 0; _i2 < _arr2.length; _i2++) {
  var generator = _arr2[_i2];
  _Object$assign(commonPrinterMethods, generator);
}
module.exports = exports["default"];